From d8583b1224a7fbb7f6b5a97839683c54985917b4 Mon Sep 17 00:00:00 2001
From: DreamMaoMao <2523610504@qq.com>
Date: Wed, 19 Nov 2025 11:10:05 +0800
Subject: [PATCH 03/16] fix: Fix blur lag

---
 src/mango.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/src/mango.c b/src/mango.c
index 69208d635..80ad2415a 100644
--- a/src/mango.c
+++ b/src/mango.c
@@ -2086,7 +2086,8 @@ static void iter_layer_scene_buffers(struct wlr_scene_buffer *buffer, int sx,
 	LayerSurface *l = (LayerSurface *)user_data;
 
 	wlr_scene_node_set_enabled(&l->blur->node, true);
-	wlr_scene_blur_set_transparency_mask_source(l->blur, buffer);
+	wlr_scene_blur_set_mask_source(l->blur, &buffer->node,
+								   BLUR_MASK_IGNORE_TRANSPARENCY);
 	wlr_scene_blur_set_size(l->blur, l->geom.width, l->geom.height);
 
 	if (blur_optimized) {
@@ -3533,7 +3534,6 @@ static void iter_xdg_scene_buffers(struct wlr_scene_buffer *buffer, int sx,
 
 	if (blur && c && !c->noblur) {
 		wlr_scene_node_set_enabled(&c->blur->node, true);
-		// wlr_scene_blur_set_transparency_mask_source(c->blur, buffer);
 		if (blur_optimized) {
 			wlr_scene_blur_set_should_only_blur_bottom_layer(c->blur, true);
 		} else {

